"#import libs/utils.inc.src"

//command: breakhash
length = imports.utils.ParamLength(params)
if length < 2 or length > 4 or imports.utils.HasFlag(params, "h", "help") then exit("<b>Usage: "+imports.utils.GetProgName()+" [hash] [max length] [(opt) min length] [(opt) char set] --numerals --uppercase --lowercase")

hash = imports.utils.GetParam(params, 0)

maxLen = imports.utils.GetParam(params, 1).to_int
minLen = imports.utils.GetParam(params, 2)
if minLen then
	minLen = minLen.to_int
else
	minLen = 0
end if
if maxLen < 0 or minLen < 0 then imports.utils.Exit("Lengths must not be negative!") 

possibilities = imports.utils.GetParam(params, 3)
if possibilities then
	possibilities = possibilities.values
else
	possibilities = []
end if

ASCII = function(min, max)
	for i in range(min, max)
		possibilities.push(char(i))
	end for
end function

if imports.utils.HasFlag(params, "l", "lowercase") then ASCII(97,122)
if imports.utils.HasFlag(params, "u", "uppercase") then ASCII(65,90)
if imports.utils.HasFlag(params, "n", "numerals") then ASCII(48,57)
if possibilities.len == 0 then imports.utils.Exit("You must specify at least one set of characters!")

Increment = function(arr, max, index)
	value = arr[index]+1
	if value < max then
		arr[index] = value
		return true
	end if
	if index == 0 then return false
	arr[index] = 0
	return Increment(arr, max, index-1)
end function

for length in range(minLen,maxLen)
	indexes = []
	for i in range(0, length-1)
		indexes.push(0)
	end for
	
	loop = true
	while loop
		try = ""
		for index in indexes
			try = try + possibilities[index]
		end for
		
		if hash == md5(try) then imports.utils.Exit("Bruteforced:"+try)
		loop = Increment(indexes, possibilities.len, indexes.len-1)
	end while
	print("Tried all combinations of "+length+" characters")
	imports.utils.Pause()
end for

imports.utils.Exit("Not found under those parameters!")
